local config = dofile_once("mods/doom_bringer/config.lua")

local spawn_distance = 800
function get_direction(x1, y1, x2, y2)
  return math.atan2((y2 - y1), (x2 - x1))
end

function get_distance2(x1, y1, x2, y2)
	return (x2 - x1) ^ 2 + (y2 - y1) ^ 2
end

local doom_bringer = EntityGetWithTag("doom_bringer")

doom_bringer_x = doom_bringer_x or 0
doom_bringer_y = doom_bringer_y or 0

if #doom_bringer > 0 then
  -- it's still alive, going to do it's chasing, save it's position for later
  doom_bringer_x, doom_bringer_y = EntityGetTransform(doom_bringer[1])
elseif GlobalsGetValue("DOOM_BRINGER_ACTIVE") == "yes" then
  -- it's dead, chase manually
  local players = EntityGetWithTag("player_unit")
  if #players > 0 then
    local player_x, player_y = EntityGetTransform(players[1])
    local direction = get_direction(doom_bringer_x, doom_bringer_y, player_x, player_y)

    doom_bringer_x = doom_bringer_x + math.cos(direction) * config.speed
    doom_bringer_y = doom_bringer_y + math.sin(direction) * config.speed
    if get_distance2(doom_bringer_x, doom_bringer_y, player_x, player_y) < spawn_distance * spawn_distance then
      local doom_bringer = EntityLoad("data/entities/animals/doom_bringer.xml", doom_bringer_x, doom_bringer_y)
      local ghost_component = EntityGetFirstComponent(doom_bringer, "GhostComponent")
      ComponentSetValue(ghost_component, "speed", config.speed)
    end
  end
end
