ModRegisterAudioEventMappings("mods/new_enemies/data/sound/GUIDs.txt")

local config = dofile_once("mods/doom_bringer/config.lua")

function OnWorldPreUpdate()
  gui = gui or GuiCreate()
  GuiStartFrame(gui)
  GuiLayoutBeginVertical(gui, 0, 0)
  if GlobalsGetValue("DOOM_BRINGER_ACTIVE", "") == "no" then
    if GuiButton(gui, 431, 0, "[Enable Doom Bringer]", 1) then
      local players = EntityGetWithTag("player_unit")
      if #players > 0 then
        local x, y = EntityGetTransform(players[1])
		local doom_bringer = EntityLoad( "data/entities/animals/doom_bringer.xml", x, y - 300)
        local ghost_component = EntityGetFirstComponent(doom_bringer, "GhostComponent")
        ComponentSetValue(ghost_component, "speed", config.speed)
        GamePlaySound( "data/audio/Desktop/event_cues.snd", "event_cues/orb_distant_monster/create", x, y )
        GameScreenshake( 100 )
        GlobalsSetValue("DOOM_BRINGER_ACTIVE", "yes")
      end
    end
  else
    if GuiButton(gui, 429, 0, "[Disable Doom Bringer]", 1) then
      local doom_bringers = EntityGetWithTag("doom_bringer")
      local players = EntityGetWithTag("player_unit")
      if #doom_bringers > 0 and #players > 0 then
        local x, y = EntityGetTransform(players[1])
        GamePlaySound( "data/audio/Desktop/projectiles.snd", "player_projectiles/sea_of_lava/create", x, y )
        EntityLoad( "data/entities/particles/image_emitters/magical_symbol_mwyah.xml", x , y )
        GameScreenshake( 100 )
        EntityKill(doom_bringers[1])
      end
      GlobalsSetValue("DOOM_BRINGER_ACTIVE", "no")
    end
  end
  GuiLayoutEnd(gui)
end

function OnPlayerSpawned(player_id)
    local entity_id = GetUpdatedEntityID()
    local x, y = EntityGetTransform(entity_id)

    GlobalsSetValue("DOOM_BRINGER_ACTIVE", "no")

    EntityLoad("data/entities/buildings/attacher.xml")
    EntityLoad("data/entities/buildings/loaded_area_checker.xml")
end